package categoryrepository

import (
	"fmt"
	categorydomain "legalgo-BE-go/internal/domain/category"

	"gorm.io/gorm/clause"
)

func (a *accessor) Update(spec categorydomain.Category) error {
	if err := a.db.Clauses(clause.OnConflict{
		Columns:   []clause.Column{{Name: "id"}},
		DoUpdates: clause.AssignmentColumns([]string{"name", "code", "updated_at"}),
	}).Select("name", "code", "updated_at").Save(&spec).Error; err != nil {
		return fmt.Errorf("failed to update category: %v", err)
	}

	return nil
}
